#include <ratio>

template<bool b> struct Bool
{
	using type = bool;
    static const type value = b;
    constexpr operator bool() const { return value; }
};

template<typename T> struct Exist;
template<>           struct Exist<Bool<true>>{ using result = Bool<true>; };

template<int n> struct Int
{
	using type = int;
    static const type value = n;
    constexpr operator int() const { return value; }
    auto operator++()    const { return Int<(n+1)>(); }
    auto operator++(int) const { return Int<(n+1)>(); }
    auto operator--()    const { return Int<(n-1)>(); }
    auto operator--(int) const { return Int<(n-1)>(); }
};

template<int n1, int n2> auto operator+(Int<n1>, Int<n2>){ return Int<n1 + n2>(); }
template<int n1, int n2> auto operator-(Int<n1>, Int<n2>){ return Int<n1 - n2>(); }
template<int n1, int n2> auto operator*(Int<n1>, Int<n2>){ return Int<n1 * n2>(); }
template<int n1, int n2> auto operator/(Int<n1>, Int<n2>){ return Int<n1 / n2>(); }
template<int n1, int n2> auto operator==(Int<n1>, Int<n2>){ return Bool<(n1 == n2)>(); }

template<int64_t n, int64_t d> struct Rat{ static const int64_t nom = n; static const int64_t den = d; operator double() const { return (double)n / (double)d; } };

template<int64_t n1, int64_t n2, int64_t d1, int64_t d2> auto operator+( Rat<n1, d1>, Rat<n2, d2> ){ using res = std::ratio_add< std::ratio<n1, d1>, std::ratio<n2, d2> >; return Rat< res::num, res::den >(); }
template<int64_t n1, int64_t n2, int64_t d1, int64_t d2> auto operator-( Rat<n1, d1>, Rat<n2, d2> ){ using res = std::ratio_subtract< std::ratio<n1, d1>, std::ratio<n2, d2> >; return Rat< res::num, res::den >(); }
template<int64_t n1, int64_t n2, int64_t d1, int64_t d2> auto operator*( Rat<n1, d1>, Rat<n2, d2> ){ using res = std::ratio_multiply< std::ratio<n1, d1>, std::ratio<n2, d2> >; return Rat< res::num, res::den >(); }
template<int64_t n1, int64_t n2, int64_t d1, int64_t d2> auto operator/( Rat<n1, d1>, Rat<n2, d2> ){ using res = std::ratio_divide< std::ratio<n1, d1>, std::ratio<n2, d2> >; return Rat< res::num, res::den >(); }


//Product type:
template<typename N, typename T> struct elem       { T val; elem():val(T()){} elem( T const& v ):val(v){} elem(T && v) :val(std::forward<T>(v)){} };
template<typename N, typename T> struct elem<N, T&>{ T val;                   elem( T const& v ):val(v){}                               };

#define el(n, T) elem< decltype(n), T >

template<typename... Ts> struct List
{
};

template<typename Nk, typename Nn, typename T> struct ProductType_;
template<typename Nk>                          struct ProductType_<Nk, Int<0>, List<>>{};
template<typename Nk, typename Nn, typename T0, typename... T>
struct ProductType_<Nk, Nn, List<T0, T...>> : elem< decltype(--Nk()), T0>, ProductType_< decltype(Nk()++), Nn, List<T...>>
{
    using ProductType_< decltype(Nk()++), Nn, List<T...>>::operator[];
    ProductType_(){}
    ProductType_(ProductType_<Nk, Nn, List<T0, T...>>const& p): elem<decltype(--Nk()), T0>(p[--Nk()]), ProductType_< decltype(Nk()++), Nn, List<T...>>( static_cast<ProductType_< decltype(Nk()++), Nn, List<T...>>const&>(p)){}
    ProductType_(ProductType_<Nk, Nn, List<T0, T...>>&&     p): elem<decltype(--Nk()), T0>(p[--Nk()]), ProductType_< decltype(Nk()++), Nn, List<T...>>( static_cast<ProductType_< decltype(Nk()++), Nn, List<T...>>&&    >(p)){}

    auto& operator= (ProductType_ const& cpy){ (static_cast<elem< decltype(--Nk()), T0>*>(this))->val = (static_cast<const elem< decltype(--Nk()), T0>*>(&cpy))->val; return *this; }

    template<typename T0c, typename... Tsc> ProductType_(T0c && t, Tsc &&... ts) : elem< decltype(--Nk()), T0>( std::forward<T0c>(t) ), ProductType_< decltype(Nk()++), Nn, List<T...>>( std::forward<Tsc>(ts)... ) {}

    T0&       operator[]( decltype(--Nk()) idx)     { return (static_cast<      elem<decltype(--Nk()), T0>*>(this))->val; }
    T0 const& operator[]( decltype(--Nk()) idx)const{ return (static_cast<const elem<decltype(--Nk()), T0>*>(this))->val; }
};

template<typename Nn, typename T> struct ProductType_<Nn, Nn, List<T> > : elem< decltype(--Nn()), T>
{
    ProductType_(){}
    ProductType_(ProductType_<Nn, Nn, List<T>>const& cpy):elem< decltype(--Nn()), T>(cpy[--Nn()]){}
    ProductType_(ProductType_<Nn, Nn, List<T>>&&     cpy):elem< decltype(--Nn()), T>(cpy[--Nn()]){}

    auto& operator= ( ProductType_<Nn, Nn, List<T>> const& cpy){ (static_cast<elem< decltype(--Nn()), T>*>(this))->val = (static_cast<const elem< decltype(--Nn()), T>*>(&cpy))->val; return *this; }

    template<typename Tc> ProductType_(Tc && t):elem< decltype(--Nn()), T>(std::forward<Tc>(t)){}
	T&        operator[]( decltype(--Nn()) idx)     { return (static_cast<      elem< decltype(--Nn()), T>*>(this))->val; }
    T const & operator[]( decltype(--Nn()) idx)const{ return (static_cast<const elem< decltype(--Nn()), T>*>(this))->val; }
};

template<typename... T> struct Tuple
{
	using size = Int<sizeof...(T)>;
    ProductType_<Int<1>, Int<sizeof...(T)>, List<T...>> p;

    Tuple(){}
    Tuple(Tuple<T...> const& pin):p(          pin.p) {}
    Tuple(Tuple<T...> &&     pin):p(std::move(pin.p)){}

    template<typename... Tin> Tuple( int dummy, Tin&&... ts):p( std::forward<Tin>(ts)... ){}

    auto& operator= (Tuple<T...> const& cpy){ p = cpy.p; return *this; }

    template<int i> auto &      operator[]( Int<i> idx)     { return p[idx]; }
    template<int i> auto const& operator[]( Int<i> idx)const{ return p[idx]; }
};

template<typename T>     struct IsTuple;
template<typename... Ts> struct IsTuple< Tuple<Ts...> >{ using result = void; };

template<typename T, typename R = typename IsTuple<std::remove_reference_t<T>>::result> auto size( T&& tuple ){ return typename std::remove_reference_t<T>::size(); }

template<typename... Ts>
auto makeTuple( Ts&&... ts){ return Tuple<std::remove_reference_t<Ts>...>( 0, std::forward<Ts>(ts)... ); }

//Expand
template<typename Ni, typename Nn> struct expand_
{
	template<typename F, typename Tup, typename... A>
	decltype(auto) operator()( F&& f, Tup&& t, A&&... a){ return expand_< decltype(++Ni()), Nn>()( std::forward<F>(f), std::forward<Tup>(t), std::forward<A>(a)..., t[--Ni()] ); }
};

template<typename Nn> struct expand_<Nn, Nn>
{
	template<typename F, typename Tup, typename... A>
	decltype(auto) operator()( F&& f, Tup&& t, A&&... a){ return f( std::forward<A>(a)..., t[--Nn()] ); }
};

template<typename F, typename Tup>
decltype(auto) expand(F&& f, Tup&& t){ return expand_<Int<1>, decltype(size(t))>()(std::forward<F>(f), std::forward<Tup>(t)); }

//Map
template<typename F, typename T, typename R = typename IsTuple<std::remove_reference_t<T>>::result>
auto Map( F&& f, T&& t)
{
	return expand( [&](auto... e){ return makeTuple( f( std::forward<decltype(e)>(e))... ); }, std::forward<T>(t) );
}

//FOLD
template<typename F> struct Foldl_inner_lambda
{
    F f;
	Foldl_inner_lambda(F&& ff):f(std::move(ff)){}
	Foldl_inner_lambda(F const& ff):f(ff){}

    template<typename T1>                                          auto operator()(T1&& t1)         { return std::forward<T1>(t1); }
    template<typename T1, typename T2>                             auto operator()(T1&& t1, T2&& t2){ return f(std::forward<T1>(t1), std::forward<T2>(t2)); }
    template<typename T1, typename T2, typename T3, typename... T> auto operator()(T1&& t1, T2&& t2, T3&& t3, T&&... t)
    {
		return this->operator()( f(std::forward<T1>(t1), std::forward<T2>(t2)), std::forward<T3>(t3), std::forward<T>(t)... );
    }
};

template<typename F, typename T>
auto Foldl(F&& f, T&& t){ return expand( Foldl_inner_lambda<std::remove_cv_t<std::remove_reference_t<F>>>(std::forward<F>(f)), std::forward<T>(t) ); }

//CONCATENATE
template<typename     T, typename   Pck> struct Concat;
template<typename     T, typename... Ts> struct Concat<T, Tuple<Ts...>>           { using result = Tuple<T, Ts...>; };
template<typename... Ts, typename     T> struct Concat<Tuple<Ts...>, T>           { using result = Tuple<Ts..., T>; };
template<typename... As, typename... Bs> struct Concat<Tuple<As...>, Tuple<Bs...>>{ using result = Tuple<As..., Bs...>; };

template<typename V, typename T>
auto append( T&& t, V&& val ){ return expand( [&](auto&&... e){ return makeTuple( std::forward<decltype(e)>(e)..., std::forward<V>(val) ); }, std::forward<T>(t) ); }

//generate nat sequence:
auto genseq( Int<1> ){ return makeTuple( Int<0>() ); }
template<int n> auto genseq(Int<n> i){ auto k = --i; return append( genseq( k ), k ); }

//Zip
template<typename F, typename T1, typename T2, typename R = typename Exist<decltype(size(std::declval<T1>()) == size(std::declval<T2>()) )>::result>
auto Zip( F&& f, T1&& t1, T2&& t2)
{
	return expand( [&](auto... ns){ return makeTuple( f( t1[ns], t2[ns] )... ); }, genseq(size(t1)) );
}

#include <iostream>
void TupleTest()
{
	auto t = makeTuple( Int<5>(), 8, Int<7>() );
	auto r = Map( [](auto x){ return x*x; }, t);

	printf("\n%i  %i  %i\n", t[Int<0>()].value, t[Int<1>()], t[Int<2>()].value);
	printf("\n%i  %i  %i\n", r[Int<0>()].value, r[Int<1>()], r[Int<2>()].value);

	auto t2 = makeTuple( Int<5>(), Int<1>(), Int<7>() );
	auto r2 = Foldl( [](auto x, auto y){ return x+y; }, t2);

	printf("\n%i  %i  %i\n", t2[Int<0>()].value, t2[Int<1>()].value, t2[Int<2>()].value);
	printf("\n%i\n", r2.value );

	auto t3 = makeTuple( Int<5>(), Int<1>(), Int<7>() );
	auto t4 = makeTuple( Int<2>(), Int<7>(), Int<9>() );
	auto r3 = Zip( [](auto x, auto y){ return x+y; }, t3, t4);

	printf("\n%i  %i  %i\n", t3[Int<0>()].value, t3[Int<1>()].value, t3[Int<2>()].value);
	printf("\n%i  %i  %i\n", t4[Int<0>()].value, t4[Int<1>()].value, t4[Int<2>()].value);
	printf("\n%i  %i  %i\n", r3[Int<0>()].value, r3[Int<1>()].value, r3[Int<2>()].value);
}

auto Add = [](auto&& x, auto&& y){ return std::forward<decltype(x)>(x)+std::forward<decltype(y)>(y); };
//auto Mul = [](auto&& x, auto&& y){ return std::forward<decltype(x)>(x)*std::forward<decltype(y)>(y); };
auto SclMul = [](auto&& scl){ return [&](auto&& x){ return scl*std::forward<decltype(x)>(x); }; };

template<typename As, typename Bs, typename Cs>
struct RungeKuttaStepper
{
	As as;
	Bs bs;
	Cs cs;

	template<typename TTime, typename TStep, typename TState, typename TRHS>
	auto eval_kn( Int<0>, TTime&& time, TStep&& h, TState&& state, TRHS&& rhs )
	{
		return makeTuple(rhs(time, std::forward<TState>(state)));
	}

	template<typename N, typename TTime, typename TStep, typename TState, typename TRHS>
	auto eval_kn( N&& n, TTime&& time, TStep&& h, TState&& state, TRHS&& rhs )
	{
		auto ks = eval_kn(--n, time, h, std::forward<TState>(state), std::forward<TRHS>(rhs) );
		auto StateAdder = [](auto&& s1, auto&& s2){ return Zip(Add, s1, s2); };
		auto StateScaler = [&](auto&& scl, auto&& s){ return Map(SclMul(scl), s); };
		auto kc = rhs( time + cs[n] * h,
			           Zip(Add, state, Map(SclMul(h), Foldl(StateAdder, Zip(StateScaler, as[n], ks) ) ) ) );
		return append(ks, kc);
	}

	template<typename TTime, typename TStep, typename TState, typename TRHS>
	auto operator()( TTime&& time, TStep&& h, TState&& state, TRHS&& rhs )
	{
		auto ks = eval_kn( --size(bs), time, h, state, rhs );
		auto StateAdder = [](auto&& s1, auto&& s2){ return Zip(Add, s1, s2); };
		auto StateScaler = [&](auto&& scl, auto&& s){ return Map(SclMul(scl), s); };
		return Zip( Add, state, Map( SclMul(h), Foldl( StateAdder, Zip(StateScaler, bs, ks))));
	}
};

void main19()
{
	//TupleTest();

	//auto h = makeTuple( makeTuple( 4, Int<6>() ), makeTuple( Int<8>(), 9) );

	//Ralston
	/*{
		using As = Tuple<	Tuple< Rat<0, 1> >,
							Tuple< Rat<2, 3> >	>;

		using Bs = Tuple<	Rat<1, 4>,
							Rat<3, 4>	>;

		using Cs = Tuple<	Rat<0, 1>,
							Rat<2, 3>	>;

		RungeKuttaStepper< As, Bs, Cs > ralston;

		//auto state = makeTuple( Rat<1, 1>() );
		auto state = makeTuple(1.0);

		auto rhs = [](auto t, auto&& x){ return makeTuple(x[Int<0>()]*x[Int<0>()] + Rat<1, 1>()); };

		auto stp = ralston( Rat<1, 1>(), Rat<25, 1000>(), state, rhs );
		auto res = stp[Int<0>()];
		//printf("%I64i/%I64i\n", res.nom, res.den);
		printf("%16.16f\n", res);
	}*/


	{
		using As = Tuple<	Tuple< Rat<0, 1> >,
							Tuple< Rat<1, 2> >,
							Tuple< Rat<0, 1>, Rat<1, 2> >,
							Tuple< Rat<0, 1>, Rat<0, 1>, Rat<1, 1> >
						>;

		using Bs = Tuple<	Rat<1, 6>,
							Rat<1, 3>,
							Rat<1, 3>,
							Rat<1, 6> >;

		using Cs = Tuple<	Rat<0, 1>,
							Rat<1, 2>,
							Rat<1, 2>,
							Rat<1, 1> >;

		RungeKuttaStepper< As, Bs, Cs > rk4;

		auto state = makeTuple(Rat<1, 1>(), Rat<2, 1>());
		auto rhs = [](auto t, auto&& x){ return makeTuple(x[Int<0>()]*x[Int<0>()] + Rat<1, 1>(), x[Int<1>()]*x[Int<1>()] + Rat<1, 1>()); };
		auto stp = rk4( Rat<1, 1>(), Rat<1, 10>(), state, rhs );
		auto res1 = stp[Int<0>()];
		auto res2 = stp[Int<1>()];
		printf("%I64i/%I64i\n", res1.nom, res1.den);
		printf("%I64i/%I64i\n", res2.nom, res2.den);
	}
}
